#pragma once
#include <fstream>
#include "ErrorProvider.h"

namespace ConfigLib
{
	//File data source class
	class FileDataSource
	{
	protected:
		std::ifstream file;				//File stream
		std::string filePath;			//Path to file to open
		SourcePos pos;					//Present source pos
		char c;							//Read char

	public:
		FileDataSource(std::string filepath);
		~FileDataSource();

		//Returns file data source selected file path
		std::string getFilePath();
		//Closes data source and change data source file (need to be opened again)
		void changeDataSource(std::string filepath);
		//Opens data source to read file
		bool open();
		//Closes data source, but saves state, after open it will continue from where it ended
		void close();
		//Resets state of data source forcing to read from the beggining again
		void reset();
		//Returns next char from data source
		char nextChar();
		//Returns present source position
		SourcePos getPos();
	};
}