#pragma once
#include <ctype.h>
#include "FileDataSource.h"
#include "Symbol.h"

namespace ConfigLib
{
	//Scanner class providing atoms recognition
	class Scanner
	{
	private:
		FileDataSource* dataSource;	//Data source to read from
		SourcePos symPos;			//Holding position of found symbol (atom)
		char input;					//Holding working char (retrieved from data source)

	public:
		Scanner(FileDataSource* source);
		~Scanner();

		//Loads first char
		void init();
		//Returns next recognized symbol
		Symbol nextSymbol();

	private:
		//Skips white space
		bool skipWhiteSpace();
		//Skips comment
		bool skipComment();
		//Tries to build one char symbol if possible
		Symbol buildOneCharSymbol();
		//Tries to build float or int constant symbol
		Symbol buildNumeric();
		//Tries to build string symbol
		Symbol buildString();
	};
}