#pragma once
#include "IObjectFactory.h"
#include "Parser.h"

namespace ConfigLib
{
	//Class checking sepantics and creating object if possible
	class Semantics
	{
	public:
		Semantics(FileDataSource* source, IObjectFactory* objFac);
		~Semantics();

		//Sets parsing results to use (results from parser)
		void setResultSource(std::list<ParserResult>* source);
		//Checks semantics and try to build object from results
		void* buildObj(std::list<ParserResult>::iterator* startPos);

	private:
		//Builds array
		void* buildArray(std::list<ParserResult>::iterator* it, int* size);
		//Deletes object attributes structure
		void deleteAttribs(std::map<std::string, Attrib>& atrs);
		//Recursive delete func for deleting arrays
		void recursiveDelete(void* ptr, int size);

	private:
		FileDataSource* ds;									//Data source for retrieving source file
		IObjectFactory* factory;							//User inmplementation of object factory
		std::list<ParserResult>* result;					//Parser result pointer
	};
}